SetType (apache-cassandra API)
Date: 2018-02-12

org.apache.cassandra.db.marshal

## Class SetType<T>

- java.lang.Object
- - org.apache.cassandra.db.marshal.AbstractType<T>
  - - org.apache.cassandra.db.marshal.CollectionType<java.util.Set<T>>
    - - org.apache.cassandra.db.marshal.SetType<T>

- All Implemented Interfaces:
    java.util.Comparator<java.nio.ByteBuffer>

      public class SetType<T>
      extends CollectionType<java.util.Set<T>>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.cassandra.db.marshal.CollectionType

      `CollectionType.Kind`

  - ### Field Summary

    - ### Fields inherited from class org.apache.cassandra.db.marshal.CollectionType

      `kind, MAX_ELEMENTS`

    - ### Fields inherited from class org.apache.cassandra.db.marshal.AbstractType

      `reverseComparator`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SetType(AbstractType<T> elements, boolean isMultiCell)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(java.nio.ByteBuffer o1, java.nio.ByteBuffer o2)`
    `AbstractType<?>` | `freeze()`
    `Term` | `fromJSONObject(java.lang.Object parsed)` Given a parsed JSON string, return a byte representation of the object.
    `AbstractType<T>` | `getElementsType()`
    `static <T> SetType<T>` | `getInstance(AbstractType<T> elements, boolean isMultiCell)`
    `static SetType<?>` | `getInstance(TypeParser parser)`
    `SetSerializer<T>` | `getSerializer()`
    `boolean` | `isByteOrderComparable()`
    `boolean` | `isCompatibleWithFrozen(CollectionType<?> previous)` A version of isCompatibleWith() to deal with non-multicell (frozen) collections
    `boolean` | `isMultiCell()`
    `boolean` | `isValueCompatibleWithFrozen(CollectionType<?> previous)` A version of isValueCompatibleWith() to deal with non-multicell (frozen) collections
    `AbstractType<T>` | `nameComparator()`
    `boolean` | `references(AbstractType<?> check)` Checks whether this type or any of the types this type contains references the given type.
    `java.util.List<java.nio.ByteBuffer>` | `serializedValues(java.util.List<Cell> cells)`
    `java.lang.String` | `toJSONString(java.nio.ByteBuffer buffer, int protocolVersion)` Converts the specified value into its JSON representation.
    `java.lang.String` | `toString(boolean ignoreFreezing)`
    `AbstractType<?>` | `valueComparator()`

    - ### Methods inherited from class org.apache.cassandra.db.marshal.CollectionType

      `asCQL3Type, enforceLimit, fromString, getString, isCollection, isCompatibleWith, isMap, isValueCompatibleWithInternal, makeCollectionReceiver, serializeForNativeProtocol, toString, validateCellValue`

    - ### Methods inherited from class org.apache.cassandra.db.marshal.AbstractType

      `asCQLTypeStringList, compareCollectionMembers, componentsCount, compose, decompose, getComponents, getString, isCounter, isEmptyValueMeaningless, isFrozenCollection, isReversed, isValueCompatibleWith, parseDefaultParameters, validate, validateCollectionMember`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Constructor Detail

    - #### SetType

          public SetType(AbstractType<T> elements,
                         boolean isMultiCell)

  - ### Method Detail

    - #### getInstance

          public static SetType<?> getInstance(TypeParser parser)
                                        throws ConfigurationException,
                                               SyntaxException

      Throws:
        `ConfigurationException`
        `SyntaxException`

    - #### getInstance

          public static <T> SetType<T> getInstance(AbstractType<T> elements,
                                                   boolean isMultiCell)

    - #### references

          public boolean references(AbstractType<?> check)

      Description copied from class: `AbstractType`
      Checks whether this type or any of the types this type contains references the given type.
      Overrides:
        `references` in class `AbstractType<java.util.Set<T>>`

    - #### getElementsType

          public AbstractType<T> getElementsType()

    - #### nameComparator

          public AbstractType<T> nameComparator()

      Specified by:
        `nameComparator` in class `CollectionType<java.util.Set<T>>`

    - #### valueComparator

          public AbstractType<?> valueComparator()

      Specified by:
        `valueComparator` in class `CollectionType<java.util.Set<T>>`

    - #### isMultiCell

          public boolean isMultiCell()

      Overrides:
        `isMultiCell` in class `AbstractType<java.util.Set<T>>`

    - #### freeze

          public AbstractType<?> freeze()

      Overrides:
        `freeze` in class `AbstractType<java.util.Set<T>>`

    - #### isCompatibleWithFrozen

          public boolean isCompatibleWithFrozen(CollectionType<?> previous)

      Description copied from class: `CollectionType`
      A version of isCompatibleWith() to deal with non-multicell (frozen) collections
      Specified by:
        `isCompatibleWithFrozen` in class `CollectionType<java.util.Set<T>>`

    - #### isValueCompatibleWithFrozen

          public boolean isValueCompatibleWithFrozen(CollectionType<?> previous)

      Description copied from class: `CollectionType`
      A version of isValueCompatibleWith() to deal with non-multicell (frozen) collections
      Specified by:
        `isValueCompatibleWithFrozen` in class `CollectionType<java.util.Set<T>>`

    - #### compare

          public int compare(java.nio.ByteBuffer o1,
                             java.nio.ByteBuffer o2)

    - #### getSerializer

          public SetSerializer<T> getSerializer()

      Specified by:
        `getSerializer` in class `CollectionType<java.util.Set<T>>`

    - #### isByteOrderComparable

          public boolean isByteOrderComparable()

      Overrides:
        `isByteOrderComparable` in class `AbstractType<java.util.Set<T>>`
      Returns:
        true IFF the byte representation of this type can be compared unsigned and always return the same result as calling this object's compare or compareCollectionMembers methods

    - #### toString

          public java.lang.String toString(boolean ignoreFreezing)

      Overrides:
        `toString` in class `AbstractType<java.util.Set<T>>`
      Parameters:
        `ignoreFreezing` - if true, the type string will not be wrapped with FrozenType(...), even if this type is frozen.

    - #### serializedValues

          public java.util.List<java.nio.ByteBuffer> serializedValues(java.util.List<Cell> cells)

      Specified by:
        `serializedValues` in class `CollectionType<java.util.Set<T>>`

    - #### fromJSONObject

          public Term fromJSONObject(java.lang.Object parsed)
                              throws MarshalException

      Description copied from class: `AbstractType`
      Given a parsed JSON string, return a byte representation of the object.
      Specified by:
        `fromJSONObject` in class `AbstractType<java.util.Set<T>>`
      Parameters:
        `parsed` - the result of parsing a json string
      Throws:
        `MarshalException`

    - #### toJSONString

          public java.lang.String toJSONString(java.nio.ByteBuffer buffer,
                                               int protocolVersion)

      Description copied from class: `AbstractType`
      Converts the specified value into its JSON representation.

      The buffer position will stay the same.

      Overrides:
        `toJSONString` in class `AbstractType<java.util.Set<T>>`
      Parameters:
        `buffer` - the value to convert
        `protocolVersion` - the protocol version to use for the conversion
      Returns:
        a JSON string representing the specified value

Copyright © 2018 The Apache Software Foundation